namespace eval button_tables {

 variable table_data {
	R0lGODlhGAAYAOMAAAAAAMbGxv//Qv//Sv//Uv//Wv//Y///a///c///e///
	hP///8bGxsbGxsbGxsbGxiH5BAEKAA8ALAAAAAAYABgAAASE8MlJq70418C7
	/94GjGRpjoEoIIAAFEMbu4abUgGQJAdgFISWgHZg3SY5RaLlCwpiBgNieZTk
	TlhS9ZFbeL8LAPgL2HbDI68YvS6Lxmp42NxOh9V2N2495oP1SHVteG10cn5k
	hmxxi3NvcIhqiiSMlI57h4eKfZoiWVlmIKIfGqWmpxURADs=
    }
    variable table [image create photo -data [set table_data]]
 variable data

 set data(init) 0
 set data(action) RESTORE
}
proc button_tables::initbutton { op args } {

  variable data
  switch $op {
    "INIT" {
      set PARENT [lindex $args 0]
      upvar [lindex $args 1] ROW
      set GDN [lindex $args 2]
      set STRUCT [lindex $args 3]
      set cmd "GidOpenMaterials Tables"
      if {$data(action) eq "SET"} {
	set state disabled
      } else {
	set state normal
      }
      set btable [Button $PARENT.btable -text "Create_Table"  -helptext "Open a window to create or to edit\na table of values" \
		      -command $cmd -state $state]
      set data(widgets,btable) $btable
      grid $btable -column 1 -row [expr $ROW+1] -sticky nw
      if {$data(action) eq "HIDE"} {
	grid remove $btable
      }
      set data(init) 1
      return  ""
    }
    "SYNC" {
      set GDN [lindex $args 0]
      set STRUCT [lindex $args 1]
      upvar \#0 $GDN GidData 
    }
    "CLOSE" {
	set data(init) 0
    }
    "DEPEND" {
      set data(action) [lindex $args 3]
      if {$data(init)} {
	switch $data(action) {
	  HIDE {
	    $data(widgets,btable) configure -state "normal"
	    if {[llength [grid info $data(widgets,btable)]]} {
	      grid remove $data(widgets,btable)
	    }
	  }
	  SET {
	    $data(widgets,btable) configure -state "disabled"
	    if {![llength [grid info $data(widgets,btable)]]} {
	      grid $data(widgets,btable)
	    }
	  }
	  RESTORE {
	    $data(widgets,btable) configure -state "normal"
	    if {![llength [grid info $data(widgets,btable)]]} {
	      grid $data(widgets,btable)
	    }
	  }
	}
      }
    }
  }
}

	    